// Copyright (c) 2014 The Chromium Embedded Framework Authors. All rights
// reserved. Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.
//
// ---------------------------------------------------------------------------
//
// This file was generated by the CEF translator tool. If making changes by
// hand only do so within the body of existing method and function
// implementations. See the translator.README.txt file in the tools directory
// for more information.
//

#include "libcef_dll/cpptoc/browser_cpptoc.h"
#include "libcef_dll/cpptoc/file_dialog_callback_cpptoc.h"
#include "libcef_dll/ctocpp/dialog_handler_ctocpp.h"
#include "libcef_dll/transfer_util.h"


// VIRTUAL METHODS - Body may be edited by hand.

bool CefDialogHandlerCToCpp::OnFileDialog(CefRefPtr<CefBrowser> browser,
    FileDialogMode mode, const CefString& title,
    const CefString& default_file_name,
    const std::vector<CefString>& accept_types,
    CefRefPtr<CefFileDialogCallback> callback) {
  if (CEF_MEMBER_MISSING(struct_, on_file_dialog))
    return false;

  // AUTO-GENERATED CONTENT - DELETE THIS COMMENT BEFORE MODIFYING

  // Verify param: browser; type: refptr_diff
  DCHECK(browser.get());
  if (!browser.get())
    return false;
  // Verify param: callback; type: refptr_diff
  DCHECK(callback.get());
  if (!callback.get())
    return false;
  // Unverified params: title, default_file_name, accept_types

  // Translate param: accept_types; type: string_vec_byref_const
  cef_string_list_t accept_typesList = cef_string_list_alloc();
  DCHECK(accept_typesList);
  if (accept_typesList)
    transfer_string_list_contents(accept_types, accept_typesList);

  // Execute
  int _retval = struct_->on_file_dialog(struct_,
      CefBrowserCppToC::Wrap(browser),
      mode,
      title.GetStruct(),
      default_file_name.GetStruct(),
      accept_typesList,
      CefFileDialogCallbackCppToC::Wrap(callback));

  // Restore param:accept_types; type: string_vec_byref_const
  if (accept_typesList)
    cef_string_list_free(accept_typesList);

  // Return type: bool
  return _retval?true:false;
}


#ifndef NDEBUG
template<> base::AtomicRefCount CefCToCpp<CefDialogHandlerCToCpp,
    CefDialogHandler, cef_dialog_handler_t>::DebugObjCt = 0;
#endif

