// Copyright (c) 2014 The Chromium Embedded Framework Authors. All rights
// reserved. Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.
//
// ---------------------------------------------------------------------------
//
// This file was generated by the CEF translator tool. If making changes by
// hand only do so within the body of existing method and function
// implementations. See the translator.README.txt file in the tools directory
// for more information.
//

#ifndef CEF_LIBCEF_DLL_CTOCPP_DICTIONARY_VALUE_CTOCPP_H_
#define CEF_LIBCEF_DLL_CTOCPP_DICTIONARY_VALUE_CTOCPP_H_
#pragma once

#ifndef USING_CEF_SHARED
#pragma message("Warning: "__FILE__" may be accessed wrapper-side only")
#else  // USING_CEF_SHARED

#include "include/cef_values.h"
#include "include/capi/cef_values_capi.h"
#include "libcef_dll/ctocpp/ctocpp.h"

// Wrap a C structure with a C++ class.
// This class may be instantiated and accessed wrapper-side only.
class CefDictionaryValueCToCpp
    : public CefCToCpp<CefDictionaryValueCToCpp, CefDictionaryValue,
        cef_dictionary_value_t> {
 public:
  explicit CefDictionaryValueCToCpp(cef_dictionary_value_t* str)
      : CefCToCpp<CefDictionaryValueCToCpp, CefDictionaryValue,
          cef_dictionary_value_t>(str) {}
  virtual ~CefDictionaryValueCToCpp() {}

  // CefDictionaryValue methods
  virtual bool IsValid() OVERRIDE;
  virtual bool IsOwned() OVERRIDE;
  virtual bool IsReadOnly() OVERRIDE;
  virtual CefRefPtr<CefDictionaryValue> Copy(
      bool exclude_empty_children) OVERRIDE;
  virtual size_t GetSize() OVERRIDE;
  virtual bool Clear() OVERRIDE;
  virtual bool HasKey(const CefString& key) OVERRIDE;
  virtual bool GetKeys(KeyList& keys) OVERRIDE;
  virtual bool Remove(const CefString& key) OVERRIDE;
  virtual CefValueType GetType(const CefString& key) OVERRIDE;
  virtual bool GetBool(const CefString& key) OVERRIDE;
  virtual int GetInt(const CefString& key) OVERRIDE;
  virtual double GetDouble(const CefString& key) OVERRIDE;
  virtual CefString GetString(const CefString& key) OVERRIDE;
  virtual CefRefPtr<CefBinaryValue> GetBinary(const CefString& key) OVERRIDE;
  virtual CefRefPtr<CefDictionaryValue> GetDictionary(
      const CefString& key) OVERRIDE;
  virtual CefRefPtr<CefListValue> GetList(const CefString& key) OVERRIDE;
  virtual bool SetNull(const CefString& key) OVERRIDE;
  virtual bool SetBool(const CefString& key, bool value) OVERRIDE;
  virtual bool SetInt(const CefString& key, int value) OVERRIDE;
  virtual bool SetDouble(const CefString& key, double value) OVERRIDE;
  virtual bool SetString(const CefString& key, const CefString& value) OVERRIDE;
  virtual bool SetBinary(const CefString& key,
      CefRefPtr<CefBinaryValue> value) OVERRIDE;
  virtual bool SetDictionary(const CefString& key,
      CefRefPtr<CefDictionaryValue> value) OVERRIDE;
  virtual bool SetList(const CefString& key,
      CefRefPtr<CefListValue> value) OVERRIDE;
};

#endif  // USING_CEF_SHARED
#endif  // CEF_LIBCEF_DLL_CTOCPP_DICTIONARY_VALUE_CTOCPP_H_

