// Copyright (c) 2014 The Chromium Embedded Framework Authors. All rights
// reserved. Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.
//
// ---------------------------------------------------------------------------
//
// This file was generated by the CEF translator tool. If making changes by
// hand only do so within the body of existing method and function
// implementations. See the translator.README.txt file in the tools directory
// for more information.
//

#ifndef CEF_LIBCEF_DLL_CTOCPP_RESOURCE_HANDLER_CTOCPP_H_
#define CEF_LIBCEF_DLL_CTOCPP_RESOURCE_HANDLER_CTOCPP_H_
#pragma once

#ifndef BUILDING_CEF_SHARED
#pragma message("Warning: "__FILE__" may be accessed DLL-side only")
#else  // BUILDING_CEF_SHARED

#include "include/cef_resource_handler.h"
#include "include/capi/cef_resource_handler_capi.h"
#include "libcef_dll/ctocpp/ctocpp.h"

// Wrap a C structure with a C++ class.
// This class may be instantiated and accessed DLL-side only.
class CefResourceHandlerCToCpp
    : public CefCToCpp<CefResourceHandlerCToCpp, CefResourceHandler,
        cef_resource_handler_t> {
 public:
  explicit CefResourceHandlerCToCpp(cef_resource_handler_t* str)
      : CefCToCpp<CefResourceHandlerCToCpp, CefResourceHandler,
          cef_resource_handler_t>(str) {}
  virtual ~CefResourceHandlerCToCpp() {}

  // CefResourceHandler methods
  virtual bool ProcessRequest(CefRefPtr<CefRequest> request,
      CefRefPtr<CefCallback> callback) OVERRIDE;
  virtual void GetResponseHeaders(CefRefPtr<CefResponse> response,
      int64& response_length, CefString& redirectUrl) OVERRIDE;
  virtual bool ReadResponse(void* data_out, int bytes_to_read, int& bytes_read,
      CefRefPtr<CefCallback> callback) OVERRIDE;
  virtual bool CanGetCookie(const CefCookie& cookie) OVERRIDE;
  virtual bool CanSetCookie(const CefCookie& cookie) OVERRIDE;
  virtual void Cancel() OVERRIDE;
};

#endif  // BUILDING_CEF_SHARED
#endif  // CEF_LIBCEF_DLL_CTOCPP_RESOURCE_HANDLER_CTOCPP_H_

